--[[
  ****************************************************************
	GLOCK - Vuln Track
	
	Written by Ogdin of the Deathreaver Legion.  Shadow Moon
	Contact via posts at http://www.atlantic-orcs.org/

	****************************************************************]]


-------------------------------------------------------------------------------
--Respond to registered events
-------------------------------------------------------------------------------
function GLOCKVuln_OnEvent()

	if event=="VARIABLES_LOADED" then GLOCKVuln_Init() end

	if event=="PLAYER_REGEN_ENABLED" then for i=1,16 do GLRaidTargets[i]=0; end end
	if event=="RAID_TARGET_UPDATE" then for i=1,16 do GLRaidTargets[i]=0; end end
	if event=="CHAT_MSG_MONSTER_EMOTE" and string.find(arg1,GLChromEmote) then for i=1,16 do GLRaidTargets[i]=0; end end

	if event=="CHAT_MSG_ADDON" then GLVuln_ChatHandle() end
	if event=="PLAYER_TARGET_CHANGED" then GLOCKVuln_TargetChanged() end
	if event=="UNIT_AURA" or event=="UNIT_AURASTATE" then if not (UnitName("Target")==Nil) then GLOCK_scanVuln() end end
	if event=="CHAT_MSG_SPELL_SELF_DAMAGE" then if UnitName("Target")==GLDTO or UnitName("Target")==GLDTW or UnitName("Target")==GLChromaggus then GBWLSpotVuln() end end

end

-------------------------------------------------------------------------------
--Initialize after Variables are Loaded
-------------------------------------------------------------------------------
function GLOCKVuln_Init()


	if not GLOCKVULN then GLOCKVULN={} end
	GV_Locale={}
	
	GLRaidTargets={}
	for i=1,16 do GLRaidTargets[i]=0; end

	--Ballpark figures for base damage
	GLOCK_ArcaneD={250,230,200,540}
	GLOCK_FireD={210,280,220,500,800,480,680,850,250,300}
	GLOCK_FrostD={525,500}
	GLOCK_NatureD={250,530,430,500}
	GLOCK_ShadowD={550,520,520,200,300}

	GLOCK_NFpre=0;
	GLOCK_NFnow=0;
	nCritVuln=0;
	GLOCK_NFtarget=0;
	
	GLDTO="Death Talon Overseer"
	GLDTW="Death Talon Wyrmguard"
	GLChromaggus="Chromaggus"
	GLChromEmote="flinches as its skin shimmers."

	GLWANDACTION="Shoot"
	GLWeaveTip="Increases Shadow damage taken by"
	GLImpBoltTip="Shadow damage increased by"
	GV_Locale["DAMAGE"]="Damage"

	GLOCK_vulns={"Curse of Shadow","Curse of the Elements","Spell Vulnerability",
			" ignore me ","Shadow Vulnerability","Arcane Weakness","Fire Weakness","Frost Weakness",
			"Nature Weakness","Shadow Weakness","Stormstrike","Fire Vulnerability","Deaden Magic"}

	if not MobResistDB then
		GLOCK_UIschools={"Arcane","Fire","Frost","Nature","Shadow"};
		GLOCK_schools={"Arcane","Fire","Frost","Nature","Shadow"};

		GLOCK_Arcane={"Arcane Explosion","Arcane Missile","Moonfire","Starfire"}
		GLOCK_Fire={"Hellfire","Immolate","Searing Pain","Conflagrate","Soul Fire","Fire Blast","Fireball","Pyroblast","Scorch","Flame Shock"}
		GLOCK_Frost={"Frostbolt","Frost Shock"}
		GLOCK_Nature={"Wrath","Earth Shock","Lightning Bolt","Chain Lightning"}
		GLOCK_Shadow={"Shadow Bolt","Mind Blast","Mind Flay","Mana Burn"}
	end

	GGShadowVulnTop:Hide()
	GGShadowVulnBottom:Hide()
	GGNightfallTop:Hide()
	GGNightfallBottom:Hide()
	

	this:RegisterEvent("UNIT_AURA");
	this:RegisterEvent("UNIT_AURASTATE");
	this:RegisterEvent("PLAYER_TARGET_CHANGED");
	this:RegisterEvent("CHAT_MSG_RAID");
	this:RegisterEvent("CHAT_MSG_RAID_LEADER");
	this:RegisterEvent("PLAYER_REGEN_ENABLED");
	this:RegisterEvent("RAID_TARGET_UPDATE");
	this:RegisterEvent("CHAT_MSG_MONSTER_EMOTE");
	this:RegisterEvent("CHAT_MSG_ADDON");
	this:RegisterEvent("UNIT_AURA");
	this:RegisterEvent("UNIT_AURASTATE");
	this:RegisterEvent("CHAT_MSG_SPELL_SELF_DAMAGE");

	DEFAULT_CHAT_FRAME:AddMessage("GLOCK Vulnerability Track Loaded")

end

-------------------------------------------------------------------------------
--Hide or Show the Vuln UI if you have a target. Initially scan debuff list of target
-------------------------------------------------------------------------------
function GLOCKVuln_TargetChanged()

	if UnitName("Target")==Nil then GLOCK_vulnbars:Hide() return end
	GLOCK_vulnbars:Show()
	GLOCK_scanVuln()

end

-------------------------------------------------------------------------------
--Handle UI Update.  Simply changes bar size based on currently stored vulns.
-------------------------------------------------------------------------------
function GLOCKVuln_OnUpdate()

	GGArcaneTxT:SetText(math.floor(GLVULNArcane*100+.5))
	GGFireTxT:SetText(math.floor(GLVULNFire*100+.5))
	GGFrostTxT:SetText(math.floor(GLVULNFrost*100+.5))
	GGNatureTxT:SetText(math.floor(GLVULNNature*100+.5))
	GGShadowTxT:SetText(math.floor(GLVULNShadow*100+.5))

	GGArcane:SetHeight(GLVULNArcane*65/2)
	GGFire:SetHeight(GLVULNFire*65/2)
	GGFrost:SetHeight(GLVULNFrost*65/2)
	GGNature:SetHeight(GLVULNNature*65/2)
	GGShadow:SetHeight(GLVULNShadow*65/2)

	
	
	if GLOCK_NFpre==0 and GLOCK_NFnow==1 then
		--Initiate 5 second nightfall timer
		GLOCK_NFtarget=GetTime()+5;
		PlaySound("Deathbind Sound")
	end
	GLOCK_NFpre=GLOCK_NFnow;

	--Scale Shadow Bolt Crit Vuln Bar based on charges Left and only show for a priest or warlock (shadow spells)
	_,GLV_Class=UnitClass("Player")
	if nCritVuln>0 and (GLV_Class=="WARLOCK" or GLV_Class=="PRIEST") then
		GGShadowVulnTop:Show()
		GGShadowVulnBottom:Show()
		GGShadowVulnTop:SetWidth(75*nCritVuln/4)
		GGShadowVulnTick:SetText(math.floor(nCritVuln))
	else
		GGShadowVulnTop:Hide()
		GGShadowVulnBottom:Hide()
	end

	--Drive Nightfall timer if needed
	if GLOCK_NFtarget>GetTime() and GLOCK_NFnow==1 then	--5 Second Timer for Nightfall Debuff
		GGNightfallTop:Show()
		GGNightfallBottom:Show()
		NFTimeLeft=GLOCK_NFtarget-GetTime();
		GGNightfallTop:SetWidth(75*(NFTimeLeft)/5)
		GGNightfallTime:SetText(string.format("%1.0d",NFTimeLeft))
	elseif GLOCK_NFtarget<=GetTime() and GLOCK_NFnow==1 then	--If nightfall overlapped, estimate time left
		GLOCK_NFtarget=GetTime()+3;
	elseif GLOCK_NFnow==0 then				--If nightfall fades, clear timer
		GGNightfallTop:Hide()
		GGNightfallBottom:Hide()
	end

	if MobResistDB==Nil then return end

	for iii=1,5 do
		if getglobal("GMin"..GLOCK_UIschools[iii].."TxT"):GetText()=="Imm" then 
			getglobal("GG"..GLOCK_UIschools[iii]):SetHeight(.05) 
			getglobal("GG"..GLOCK_UIschools[iii].."TxT"):SetText("0") 
		end
	end

end

-------------------------------------------------------------------------------
--Scan target debuffs and buffs for known amplifications
-------------------------------------------------------------------------------
function GLOCK_scanVuln()

--GLOCK_vulns={"Curse of Shadow","Curse of the Elements","Spell Vulnerability",
--	" jjj ","Shadow Vulnerability","Arcane Weakness","Fire Weakness","Frost Weakness",
--	"Nature Weakness","Shadow Weakness","Stormstrike","Fire Vulnerability","Deaden Magic"}

	GLVULNArcane=1
	GLVULNFire=1
	GLVULNFrost=1
	GLVULNNature=1
	GLVULNShadow=1
	GLOCK_NFnow=0
	nCritVuln=0

	for ji=1,16 do 

		GLVTooltip:ClearLines();	
		GLVTooltip:SetUnitDebuff("Target",ji);
		GSCALEID=0
		
		for k=1,13 do if GLVTooltipTextLeft1:GetText()==GLOCK_vulns[k] then GSCALEID=k; end end

		if GSCALEID==1 then GLVULNArcane=GLVULNArcane*1.1 GLVULNShadow=GLVULNShadow*1.1 end
		if GSCALEID==2 then GLVULNFire=GLVULNFire*1.1 GLVULNFrost=GLVULNFrost*1.1 end
		if GSCALEID==3 then GLOCK_NFnow=1 GLVULNShadow=GLVULNShadow*1.15 GLVULNArcane=GLVULNArcane*1.15 GLVULNFire=GLVULNFire*1.15 GLVULNFrost=GLVULNFrost*1.15 GLVULNNature=GLVULNNature*1.15 end
		if GSCALEID==5 then 
			_, ndebuffs, _=UnitDebuff("Target",ji)
			tTipAmp=GLVTooltipTextLeft2:GetText()
			if string.find(tTipAmp,GLWeaveTip) then GLVULNShadow=GLVULNShadow*(1+.03*ndebuffs) end  --Priest Shadow Weaving
			if string.find(tTipAmp,GLImpBoltTip) then nCritVuln=ndebuffs GLVULNShadow=GLVULNShadow*1.2 end   --Warlock Improved bolt talent
		end
		if GSCALEID==6 then GLVULNArcane=GLVULNArcane*2 end
		if GSCALEID==7 then GLVULNFire=GLVULNFire*2 end
		if GSCALEID==8 then GLVULNFrost=GLVULNFrost*2 end
		if GSCALEID==9 then GLVULNNature=GLVULNNature*2 end
		if GSCALEID==10 then GLVULNShadow=GLVULNShadow*2 end
		if GSCALEID==11 then GLVULNNature=GLVULNNature*1.2 end
		if GSCALEID==12 then _, ndebuffs, _=UnitDebuff("Target",ji) GLVULNFire=GLVULNFire*(1+.03*ndebuffs) end
			
		GLVTooltip:ClearLines();
	end

	for ji=1,16 do 
		GLVTooltip:ClearLines();	
		GLVTooltip:SetUnitBuff("Target",ji);
		GSCALEID=0
		for k=1,13 do if GLVTooltipTextLeft1:GetText()==GLOCK_vulns[k] then GLSCALEID=k; end end
		if GSCALEID==13 then GLVULNShadow=GLVULNShadow*0.5 GLVULNArcane=GLVULNArcane*0.5 GLVULNFire=GLVULNFire*0.5 GLVULNFrost=GLVULNFrost*0.5 GLVULNNature=GLVULNNature*0.5 end
		GLVTooltip:ClearLines();
	end


	if UnitName("Target")==GLDTO or UnitName("Target")==GLDTW or UnitName("Target")==GLChromaggus then 
		GLVULNShadow=GLVULNShadow/3 GLVULNArcane=GLVULNArcane/3 GLVULNFire=GLVULNFire/3 GLVULNFrost=GLVULNFrost/3 GLVULNNature=GLVULNNature/3 
		GBWLVuln() 
	end

end


-------------------------------
--If a value for the current BWL vuln target is known, amplify accordingly
-------------------------------
function GBWLVuln()

	--Handle Chromaggus as GLRaidTargets[1]
	if UnitName("Target")=="Chromaggus" then 
		if GLRaidTargets[1]==1 then GLVULNArcane=GLVULNArcane*9 end
		if GLRaidTargets[1]==2 then GLVULNFire=GLVULNFire*9 end
		if GLRaidTargets[1]==3 then GLVULNFrost=GLVULNFrost*9 end
		if GLRaidTargets[1]==4 then GLVULNNature=GLVULNNature*9 end
		if GLRaidTargets[1]==5 then GLVULNShadow=GLVULNShadow*9 end
	return end

	GLRaidID=GetRaidTargetIndex("Target");
	if GLRaidID==nil then return end
	
	if GLRaidTargets[GLRaidID]==1 then GLVULNArcane=GLVULNArcane*9 end
	if GLRaidTargets[GLRaidID]==2 then GLVULNFire=GLVULNFire*9 end
	if GLRaidTargets[GLRaidID]==3 then GLVULNFrost=GLVULNFrost*9 end
	if GLRaidTargets[GLRaidID]==4 then GLVULNNature=GLVULNNature*9 end
	if GLRaidTargets[GLRaidID]==5 then GLVULNShadow=GLVULNShadow*9 end

end

-------------------------------------------------------------------------------
--Track damage dealt and determine if the BWL mob is vulnerable to this school
-------------------------------------------------------------------------------
function GBWLSpotVuln()

	gstart=nil gdamagetype=nil gspell=nil gresisted=nil gdamageamount=nil

	gstart, gend, gspell, ghitcrit, gtargetname, gdamageamount, gdamagetype = 
		string.find(arg1, "Your (.+) (.+)s (.+) for (.+) (.+) damage.")
	if not gstart then return end

	gstart, gend, gresisted = string.find(arg1," %((.+) resisted")
	if gresisted==nil then gresisted=0 end


	GLBaseDmg=0

	for index,value in ipairs(GLOCK_Arcane) do if string.find(arg1,value) then GLBaseDmg=GLOCK_ArcaneD[index] gdamagetype=GLOCK_UIschools[1] end end
	for index,value in ipairs(GLOCK_Fire) do if string.find(arg1,value) then GLBaseDmg=GLOCK_FireD[index] gdamagetype=GLOCK_UIschools[2] end end
	for index,value in ipairs(GLOCK_Frost) do if string.find(arg1,value) then GLBaseDmg=GLOCK_FrostD[index] gdamagetype=GLOCK_UIschools[3] end end
	for index,value in ipairs(GLOCK_Nature) do if string.find(arg1,value) then GLBaseDmg=GLOCK_NatureD[index] gdamagetype=GLOCK_UIschools[4] end end
	for index,value in ipairs(GLOCK_Shadow) do if string.find(arg1,value) then GLBaseDmg=GLOCK_ShadowD[index] gdamagetype=GLOCK_UIschools[5] end end

	if string.find(arg1,GLWANDACTION) then
			GLVTooltip:SetInventoryItem("Player", 18);
			lines = GLVTooltip:NumLines();		
			for i=2, lines do
				for ii=1,5 do if string.find(GLOCK_schools[ii].." "..GV_Locale["DAMAGE"]) then gdamagetype=GLOCK_UIschools[ii] end end
				tmpText = getglobal("GLVTooltipTextLeft"..i);
				tmpStr=tmpText:GetText()
				if (tmpStr) then
					if string.find(tmpStr,"-") then 
						gstart, gend, gwandl, gwandh, gdamagetype=string.find(tmpStr,"(.+) %- (.+) (.+) Damage")
						GLBaseDmg=(tonumber(gwandh)+tonumber(gwandl))/2
					end
				end
					
			end
	end

	
	GLBaseDmg=GLBaseDmg*2  --Ballpark base damage w/ gear and talent and debuff bonuses and crits	
	
	if GLBaseDmg==0 then return end  --if no spell was found with a base damage that we know

	GLRaidID=GetRaidTargetIndex("Target");
	if UnitName("Target")==GLChromaggus then GLRaidID=1 end
	if GLRaidID==nil then return end
	
	for i=1,5 do if gdamagetype==GLOCK_schools[i] then GTempSchoolID=i end end
	
	if (gdamageamount+gresisted)>GLBaseDmg then 
		GLRaidTargets[GLRaidID]=GTempSchoolID
		SendAddonMessage("GLOCKV",GLRaidID..GLRaidTargets[GLRaidID],"RAID")
	end
end


-------------------------------------------------------------------------------
--Parse Vuln info as it's received in chat channel
-------------------------------------------------------------------------------
function GLVuln_ChatHandle()
	if arg4==UnitName("Player") then return end
	if string.find(arg1,"GLOCKV") then
		GLRaidTargets[tonumber(string.sub(arg2,1,1))]=tonumber(string.sub(arg2,2,2))
	end
end

-------------------------------------------------------------------------------
--Catch raid chat from CTRA boss mods and such
-------------------------------------------------------------------------------
function GLVuln_CTRACatch()

	if string.find(arg1,"SPELL VULNERABILITY CHANGED") then
		for i=1,16 do GLRaidTargets[i]=0; end
	end

	if string.find(arg1,"NEW SPELL VULNERABILITY:") then
		GLOCK_temp1=string.find(arg1,":");
		GLOCK_temp2=string.find(arg1,"*",GLOCK_temp1)
		TempSchool=string.sub(arg1,GLOCK_temp1+2,GLOCK_temp1-2)
		for i=1,5 do if string.lower(TempSchool)==string.lower(GLOCK_schools[i]) then GLRaidTargets[1]=i; end end
	end
end